Bug 314821 - Slapd segfaults, leaving LDAP database corrupt
Slapd segfaults, leaving LDAP database corrupt
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: openldap (Show other bugs)
rawhide
i386 Linux
urgent Severity high
: ---
: ---
Assigned To: Jan Safranek
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-10-01 19:36 EDT by W. Michael Petullo
Modified: 2007-11-30 17:12 EST (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-10-04 04:27:18 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
slapd.conf, ldap.conf and LDAP database (4.97 KB, text/plain)
2007-10-01 19:36 EDT, W. Michael Petullo
no flags Details

  None (edit)
Description W. Michael Petullo 2007-10-01 19:36:57 EDT
Description of problem:
Slapd segfaults, leaving LDAP database corrupt.

Version-Release number of selected component (if applicable):
openldap-servers-2.3.38-2.fc8

How reproducible:
Every time

Steps to Reproduce:
1. Configure slapd to accept connections via LDAPS
2. Start slapd with "service ldap start."
3. Stop slapd with "service ldap stop."
4. Manually start slapd with "slapd /usr/sbin/slapd -h ' ldaps:///' -u ldap"
  
Actual results:
Slapd crashes and database is corrupt.  Dmesg says:

slapd[9865]: segfault at 00000046 eip 001c5474 esp b7761800 error 4

Gdb says:

Couldn't read floating-point and SSE registers: No such device.
(gdb) ba
#0  0x0011e3a1 in _dl_debug_state () from /lib/ld-linux.so.2
#1  0x00000003 in ?? ()
#2  0x00000006 in ?? ()
#3  0xbfe6d7c4 in ?? ()
#4  0x00000001 in ?? ()
#5  0x00000000 in ?? ()

Expected results:
Slapd should start.

Additional info:
Comment 1 W. Michael Petullo 2007-10-01 19:36:57 EDT
Created attachment 213091 [details]
slapd.conf, ldap.conf and LDAP database
Comment 2 Jan Safranek 2007-10-03 03:16:49 EDT
I am not sure if I reproduced the bug correctly, but something very strange is
happening inside Berkeley DB. It does not matter how I start slapd, but second
time I start it, it fails to read from database and crashes...

I downgraded bdb back to 4.4.20 and it works. Could you please try if it works
for you? You can find it at http://people.redhat.com/jsafrane/bugs/314821/

In the meantime I'll try to figure out what's wrong with it.
Comment 3 Jan Safranek 2007-10-03 04:42:25 EDT
Hm, BDB 4.6 has new locking mechanism and openldap 2.3.38 does not support it
yet... Why they do not write it into release notes/readme/changelog???

Please test the version mentioned in #2 and let me know as soon as possible, I'd
like to fix it before Fedora 8 gets out.
Comment 4 W. Michael Petullo 2007-10-03 20:04:41 EDT
I tried your packages (Comment #2) and they seem to work fine. I "system ldap
restart"'ed, "kill -9"'ed and rebooted. The database did not become corrupt.
Comment 5 Jan Safranek 2007-10-04 02:56:41 EDT
Thank you very much! It's strange nobody noticed it in Fedora 8 test releases -
it seems to me nobody is using it...
Comment 6 Jan Safranek 2007-10-04 04:27:18 EDT
Fixed in openldap-servers-2.3.38-3.fc8

Note You need to log in before you can comment on or make changes to this bug.